zoukankan      html  css  js  c++  java
  • Fliptile 翻格子游戏

                问题 B: [Usaco2007 Open]Fliptile 翻格子游戏

                  时间限制: 5 Sec  内存限制: 128 MB

    题目描述

    Farmer John knows that an intellectually satisfied cow is a happy cow who will give more milk. He has arranged a brainy activity for cows in which they manipulate an M x N grid (1 <= M <= 15; 1 <= N <= 15) of square tiles, each of which is colored black on one side and white on the other side. As one would guess, when a single white tile is flipped, it changes to black; when a single black tile is flipped, it changes to white. The cows are rewarded when they flip the tiles so that each tile has the white side face up. However, the cows have rather large hooves and when they try to flip a certain tile, they also flip all the adjacent tiles (tiles that share a full edge with the flipped tile). Since the flips are tiring, the cows want to minimize the number of flips they have to make. Help the cows determine the minimum number of flips required, and the locations to flip to achieve that minimum. If there are multiple ways to achieve the task with the minimum amount of flips, return the one with the least lexicographical ordering in the output when considered as a string. If the task is impossible, print one line with the word "IMPOSSIBLE".

     约翰知道,那些高智力又快乐的奶牛产奶量特别高.所以他做了一个翻瓦片的益智游戏来娱乐奶牛.在一个M×N(1≤M,N≤15)的骨架上,每一个格子里都有一个可以翻转的瓦片.瓦片的一面是黑色的,而另一面是白色的.对一个瓦片进行翻转,可以使黑变白,也可以使白变黑.然而,奶牛们的蹄子是如此的巨大而且笨拙,所以她们翻转一个瓦片的时候,与之有公共边的相邻瓦片也都被翻转了.那么,这些奶牛们最少需要多少次翻转,使所有的瓦片都变成白面向上呢?如杲可以做到,输出字典序最小的结果(将结果当成字符串处理).如果不能做到,输出“IMPOSSIBLE”.

    输入

    * Line 1: Two space-separated integers: M and N

    * Lines 2..M+1: Line i+1 describes the colors (left to right) of row i of the grid with N space-separated integers which are 1 for black and 0 for white

        第1行输入M和N,之后M行N列,输入游戏开始时的瓦片状态.0表示白面向上,1表示黑面向上.

    输出

    * Lines 1..M: Each line contains N space-separated integers, each specifying how many times to flip that particular location.

        输出M行,每行N个用空格隔开的整数,表示对应的格子进行了多少次翻转.

    样例输入

    4 4
    1 0 0 1
    0 1 1 0
    0 1 1 0
    1 0 0 1
    
    
    

    样例输出

    0 0 0 0
    1 0 0 1
    1 0 0 1
    0 0 0 0
    
    OUTPUT DETAILS:
    
    After flipping at row 2 column 1, the board will look like:
    0 0 0 1
    1 0 1 0
    1 1 1 0
    1 0 0 1
    
    After flipping at row 2 column 4, the board will look like:
    0 0 0 0
    1 0 0 1
    1 1 1 1
    1 0 0 1
    
    After flipping at row 3 column 1, the board will look like:
    0 0 0 0
    0 0 0 1
    0 0 1 1
    0 0 0 1
    
    After flipping at row 3 column 4, the board will look like:
    0 0 0 0
    0 0 0 0
    0 0 0 0
    0 0 0 0
    
    Another solution might be:
    0 1 1 0
    0 0 0 0
    0 0 0 0
    0 1 1 0
    but this solution is lexicographically higher than the solution above.
    

    提示

    (⊙v⊙)嗯,单纯的读完题我是绝对没有想到会打成状压的,然而我考试打了一个大爆搜。。。

    因为一个格子被翻出来两次后所有周围的格子都相当于没有翻,所以最终的结果矩阵只能是01矩阵

    然后我们知道这一性质后:就可以用状压了::

      我们枚举第一行的状态:(1<<m)-1,然后就可以根据第一行的状态推出以下几行的状态,就是让第二行执行完这个状态后,第一行的所有格子必须全部为白色,所以递推出最后一层的状态,判断是否合法,只要合法就直接输出,因为我们枚举的时候就是默认按照字典序进行枚举的。如果枚举完了找不到状态,那就是没有解。
      在orz一下大佬wxh。考试的时候打出了正解一A,此等大佬不是我等蒟蒻所能仰望的( ⊙ o ⊙ )!
  • 相关阅读:
    简单的自我介绍
    学习总结(北航助教陈彦吉)
    2019春季第十二周助教总结
    2019春季第十一周助教总结
    第十一周作业
    2019春季第十周助教总结
    2019春季第九周助教总结
    第九周作业
    2019春季第八周助教总结
    第八周作业
  • 原文地址:https://www.cnblogs.com/Maplers/p/7277668.html
Copyright © 2011-2022 走看看